package com.loafle.overflow.module.email.service;

import com.loafle.overflow.commons.utils.EmailSender;
import com.loafle.overflow.module.domain.dao.DomainDAO;
import com.loafle.overflow.module.domain.dao.DomainMemberDAO;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.domain.model.DomainMember;
import com.loafle.overflow.module.domain.service.DomainMemberService;
import com.loafle.overflow.module.domain.service.DomainService;
import com.loafle.overflow.module.email.dao.EmailAuthDAO;
import com.loafle.overflow.module.email.model.EmailAuth;
import com.loafle.overflow.module.member.dao.MemberDAO;
import com.loafle.overflow.module.member.model.Member;
import com.loafle.overflow.module.meta.model.MetaMemberStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mail.MailException;
import org.springframework.stereotype.Service;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Date;
import java.util.List;

/**
 * Created by geek on 17. 6. 28.
 */
@Service("EmailAuthService")
public class EmailAuthService {

    @Autowired
    private EmailAuthDAO emailAuthDAO;

    @Autowired
    private MemberDAO memberDAO;

    @Autowired
    private DomainDAO domainDAO;

    @Autowired
    private DomainMemberDAO domainMemberDAO;

    @Autowired
    private EmailSender emailSender;


    public EmailAuth sendEmailByMember(long memberId, String memberEmail) throws UnsupportedEncodingException, MailException {

        EmailAuth auth = new EmailAuth();
        auth.setMember(new Member(memberId));
        // Todo AuthKey Generation

        String en = emailSender.encrypt(memberEmail);
        auth.setEmailAuthKey(en);

        String encode = URLEncoder.encode(en, "UTF-8");

//        System.out.println("encode = [" + encode + "]");
        emailSender.sendSimpleEmail(memberEmail, "Confirm Email", "http://127.0.0.1:19080/account/check_email?key="+ encode +"\r\nConfirm Email");

        this.emailAuthDAO.save(auth);

        return auth;
    }

    public EmailAuth read(long id) {
        return this.emailAuthDAO.findOne(id);
    }

    public EmailAuth readByAuthKey(String authKey) throws UnsupportedEncodingException {
        System.out.println("authKey = [" + authKey + "]");
        String deStr = URLDecoder.decode(authKey, "UTF-8");
        System.out.println("deStr = [" + deStr + "]");

        EmailAuth auth = this.emailAuthDAO.findByEmailAuthKey(deStr);

        if (auth != null) {
            auth.setAuthConfirmDate(new Date());
            this.emailAuthDAO.save(auth);
            auth.getMember().setStatus(new MetaMemberStatus((short)2));
            this.memberDAO.save(auth.getMember());

            Domain domain = new Domain();
            domain.setName(auth.getMember().getCompanyName());
            Domain domain1 = this.domainDAO.save(domain);

            DomainMember domainMember = new DomainMember();
            domainMember.setDomain(domain1);
            domainMember.setMember(auth.getMember());
            this.domainMemberDAO.save(domainMember);
        }

        return auth;
    }

    // dZQgXM1o/Cx48X8DM+6ec/oPfqA2l/LdWtijOZ2EnWk=
    // dZQgXM1o/Cx48X8DM 6ec/oPfqA2l/LdWtijOZ2EnWk=

    public List<EmailAuth> readByMember(long memberId) {
        return this.emailAuthDAO.findByMember(new Member(memberId));
    }

    public EmailAuth modify(EmailAuth emailAuth) {
        return this.emailAuthDAO.save(emailAuth);
    }



}
