package com.loafle.overflow.module.generator.service;

import com.loafle.overflow.crawler.config.*;
import com.loafle.overflow.module.meta.model.MetaSensorItemKey;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.sensor.model.SensorItem;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.type.TypeReference;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 17. 9. 6.
 */
@Service("InfraServiceMysqlGenerator")
public class InfraServiceMysqlGenerator {

    @Autowired
    private GenerateUtil generateUtil;

    public void process(List<SensorItem> sensorItems, Map<Integer, MetaSensorItemKey> keyMap, Sensor dbSensor, Config config) throws IOException {


//        List<Keys> keysList = new ArrayList<>();
//        for(SensorItem sItem : sensorItems) {
//            keys = new Keys();
//            keys.setMetric(sItem.getItem().getKey());
//            keys.setKey(KeyMap.get(sItem.getItem().getId()).getKey());
//            keysList.add(keys);
//        }
//        item.setKeys(keysList);
        Map<String, List<MetaSensorItemKey>> metricMap = null;
        metricMap = this.generateUtil.sortItems(sensorItems, keyMap);

        List<Item> itemList = new ArrayList<>();

        QueryInfo queryInfo = null;
        MappingInfo mappingInfo = null;

        List<Keys> keysList = null;
        MetaSensorItemKey tempItemKey = null;
        Keys keys = null;
        Item item = null;
        StringBuffer stringBuffer = new StringBuffer();
        for(Map.Entry<String, List<MetaSensorItemKey>> elems : metricMap.entrySet()) {

            keysList =  new ArrayList<>();
            item = new Item();
            stringBuffer.setLength(0);

            stringBuffer.append(elems.getKey());

            stringBuffer.append(" where ");
            for(int indexI = 0; indexI < elems.getValue().size(); ++indexI) {
                tempItemKey = elems.getValue().get(indexI);

                stringBuffer.append("variable_name = '");
                stringBuffer.append(tempItemKey.getKey());
                stringBuffer.append("'");

                if(indexI + 1 < elems.getValue().size()) {
                    stringBuffer.append(" or ");
                }
                keysList.add(this.generateUtil.createKeys(tempItemKey));
            }



            List<String> keyColumns = null;
            String valueColumn = null;

            String json = tempItemKey.getOption();
            if(json != null && json.length() > 0) {
                HashMap<String,Object> optionMap;
                optionMap = new ObjectMapper().readValue(json, new TypeReference<HashMap<String,Object>>() {});

                Object obj = null;
                obj = optionMap.get("valueColumn");
                if(obj != null) {
                    valueColumn = (String)obj;
                }

                obj = optionMap.get("keyColumns");
                if(obj != null) {
                    keyColumns = (List<String>)obj;
                }
            }

            queryInfo = new QueryInfo();
            queryInfo.setQuery(stringBuffer.toString());

            mappingInfo = new MappingInfo();
            mappingInfo.setParseDirection("row");
            mappingInfo.setValueColumn(valueColumn);
            mappingInfo.setKeyColumns(keyColumns);

            item.setMappingInfo(mappingInfo);
            item.setQueryInfo(queryInfo);
            item.setKeys(keysList);

            itemList.add(item);

        }

        config.setItems(itemList);


//        ObjectMapper objectMapper = new ObjectMapper();
//
//        return objectMapper.writeValueAsString(config);
    }

//    public void setQueryAndMapping(MetaCrawler metaCrawler, List<Keys> keysList, QueryInfo queryInfo, MappingInfo mappingInfo) {
//
//        switch (metaCrawler.getId()) {
//            case 11: // mysql
//            {
//                String query = "show status where ";
////                queryInfo.setQuery("show status where ");
//
//                Keys keys = null;
//                for(int indexI = 0 ; indexI < keysList.size(); ++indexI) {
//                    keys = keysList.get(indexI);
//                    query += "variable_name = '";
//                    query += keys.getKey();
//                    query += "'";
//                    if(indexI + 1 < keysList.size()) {
//                        query += " or ";
//                    }
//                }
//
//                queryInfo.setQuery(query);
//
//                mappingInfo.setParseDirection("row");
//                mappingInfo.setValueColumn("Value");
//
//                List<String> keyColumns = new ArrayList<>();
//                keyColumns.add("Variable_name");
//
//                mappingInfo.setKeyColumns(keyColumns);
//            }
//            break;
//        }
//
//    }
}
