package com.loafle.overflow.module.generator.service;

import com.loafle.overflow.commons.model.PageParams;
import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.infra.service.InfraService;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.sensor.model.SensorItem;
import com.loafle.overflow.module.sensor.service.SensorItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.List;

/**
 * Created by snoop on 17. 9. 6.
 */
@Service("SensorConfigGenerator")
public class SensorConfigGenerator {

    @Autowired
    private SensorItemService sensorItemService;

    @Autowired
    private InfraService infraService;

    @Autowired
    private InfraHostGenerator infraHostGenerator;

    @Autowired
    private InfraServiceGenerator infraServiceGenerator;


    public String generate(Sensor sensor) throws IOException {
        PageParams pageParams = new PageParams();
        pageParams.setPageNo(0);
        pageParams.setCountPerPage(Integer.MAX_VALUE);
        pageParams.setSortCol("id");
        pageParams.setSortDirection("descending");
        Page<SensorItem> dbItemList = this.sensorItemService.readAllBySensor(sensor, pageParams);

        List<SensorItem> sensorItems = dbItemList.getContent();

        if(sensorItems.size() <= 0) {
            return "";
        }
        Sensor dbSensor = sensorItems.get(0).getSensor();

        Infra infra = this.infraService.readByTarget(dbSensor.getTarget());

        // 7 = Infra OS Service
        if(infra.getInfraType().getId() == 7) {
            return this.infraServiceGenerator.process(dbSensor, sensorItems, infra);
        }
        if(infra.getInfraType().getId() == 2) {
            return this.infraHostGenerator.process(dbSensor, sensorItems, infra);
        }

        return null;
    }




}
