package com.loafle.overflow.module.history.service;

import com.loafle.overflow.commons.model.PageParams;
import com.loafle.overflow.commons.utils.PageUtil;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.history.dao.HistoryDAO;
import com.loafle.overflow.module.history.model.History;
import com.loafle.overflow.module.meta.model.MetaHistoryType;
import com.loafle.overflow.module.probe.model.Probe;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

@Service("HistoryService")
public class HistoryService {

    @Autowired
    private HistoryDAO historyDAO;

    public History regist(History history) {
        return this.historyDAO.save(history);
    }


    public Page<History> readAllByProbeAndType(Probe probe, MetaHistoryType type, PageParams pageParams) {
        return this.historyDAO.findAllByProbeAndType(probe, type, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByProbe(Probe probe, PageParams pageParams) {
        return this.historyDAO.findAllByProbe(probe, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomain(Domain domain, PageParams pageParams) {
        return this.historyDAO.findAllByDomain(domain, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomainAndType(Domain domain, MetaHistoryType type, PageParams pageParams) {
        return this.historyDAO.findAllByDomainAndType(domain, type, PageUtil.getPageRequest(pageParams));
    }

}
